#lang sicp

(define (first-denomination coin-values)
  (car coin-values))
(define (except-first-denomination coin-values)
  (cdr coin-values))
(define (no-more? coin-values)
  (null? coin-values))

; The answer will not be affected by the order of the list. We
; are still dividing cases into "doesn't use the first coin"
; and "uses at least one instance of first coin". However I
; suspect it will impact the performace, although I haven't
; formally proven it.
